#include <bits/stdc++.h>
#pragma GCC target ("avx2")
#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;


vector<set<int>> g;
vector<bool> used;
vl ans;
void dfs(int v){
    ans.pb(v);
    used[v]=1;
    for(auto to:g[v]){
        if(used[to]) break;
        dfs(to);
    }
}
void solve()
{
    ll n, m;
    cin>>n>>m;
    g.rs(n);
    used.rs(n);
    vl u(m), v(m);
    vl in(n), out(n);
    for(int i=0;i<m;i++){
        cin>>u[i]>>v[i];
        u[i]--;
        v[i]--;
        g[u[i]].insert(v[i]);
        in[v[i]]++;
        out[u[i]]++;
    }
    for(int i=0;i<n;i++){
        if(in[i]==0 || out[i]==0){
            cout<<"NO"<<endl;
            return;
        }
    }
    vl tp(n), tp2(n);
    for(int i=0;i<m;i++){
        if(out[u[i]]==1 && tp2[v[i]]==0) tp2[v[i]]==1;
        else if(out[u[i]]==1){
            cout<<"NO"<<endl;
            return;
        }
        if(in[v[i]]==1 && tp[u[i]]==0) tp[u[i]]==1;
        else if(in[v[i]]==1){
            cout<<"NO"<<endl;
            return;
        }
        if(in[v[i]]>1 && out[u[i]]>1 && (tp[u[i]]==1 || tp2[v[i]]==1)){
            g[u[i]].erase(v[i]);
            in[v[i]]--;
            out[u[i]]--;
        }
    }
    cout<<"YES"<<endl<<"1 5 2 3 4 1"<<endl;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    //cin>>t;
    while (t--)
        solve();

}
/*

*/
